import { Listener, ObserverValues, SetOptions, StarOrKey } from '../types';
declare class Observer<T = Record<string, any>> {
    #private;
    constructor(initialValues?: T);
    subscribe<StateType extends T>(key: StarOrKey<keyof StateType> | Array<keyof StateType>, listener: Listener): () => void;
    set<StateType>(values: ObserverValues<StateType, T>, { silent }?: SetOptions): void;
    get<StateType extends T>(key: keyof StateType | Array<keyof StateType>): any;
    get state(): T;
    isValid(key: string): boolean;
}
declare const observer: Observer<Record<string, any>>;
export { Observer, observer };
