export declare type Listener = (value: any) => void;
export declare type PartialValues<S, T> = Partial<S extends object ? S : T>;
export declare type ValuesSetter<S, T> = (state: S extends object ? S : T) => PartialValues<S, T>;
export declare type ObserverValues<S, T> = PartialValues<S, T> | ValuesSetter<S, T>;
export declare type SetOptions = {
    silent?: boolean;
};
export declare type CacheData = {
    setter?: string;
    getter?: string;
    value?: any;
    listeners?: Set<Listener>;
};
export declare type Setter<T> = T | ((prev: T) => T);
export declare type StarOrKey<T> = '*' | T;
export declare type WithSetters<T> = T extends object ? {
    [K in keyof T as `set${Capitalize<string & K>}`]: (value: Setter<T[K]>) => void;
} & T & {
    set?: (values: ObserverValues<T, Record<string, any>>, options?: SetOptions) => void;
} : T;
